<template>
	<div class="login-card">
		<div class="login-card-title d-flex justify-center mb-5">
			<span style="font-size: 36px">Welcome to <span class="font-weight-bold" style="color: #0065bd">Chatly</span></span>
		</div>
		<v-card class="pa-10">
			<v-form ref="loginForm" lazy-validation v-model="form.valid" @submit.prevent="login">
				<div class="d-flex flex-column">
					<div class="form-container">
						<v-text-field label="Email" type="text" v-model="form.data.email" single-line outlined hide-details></v-text-field>
					</div>
					<div class="form-container">
						<v-text-field label="Password" v-model="form.data.password" single-line outlined hide-details :append-icon="show_password ? 'mdi-eye' : 'mdi-eye-off'" :type="show_password ? 'text' : 'password'" @click:append="show_password = !show_password"></v-text-field>
					</div>
				</div>
				<div class="mb-5">
					<v-btn type="submit" color="primary" dark block elevation="0" large :loading="form.loading">Log in</v-btn>
				</div>
				<div class="d-flex align-center justify-space-between">
					<v-checkbox class="mt-0" v-model="remember" label="Remember me" value="red" hide-details></v-checkbox>
					<NuxtLink class="text-decoration-none" tag="a" :to="{ name: 'forgot-password' }"><i>Forgot Password?</i></NuxtLink>
				</div>

				<div class="d-flex justify-end mt-5">
					<p class="mb-0">
						2021 <span style="color: #0065bd">{{ this.$config.crr_name }}</span
						>. All rights reserved.
					</p>
				</div>
			</v-form>
		</v-card>
	</div>
</template>

<script>
export default {
	data: () => ({
		get_path: '',
		logo_url: '',
		show_password: false,
		remember: false,
		form: {
			valid: true,
			loading: false,
			data: {},
			rules: {
				email: [(v) => !!v || 'E-Mail is a required field.', (v) => /.+@.+/.test(v) || 'Invalid E-Mail address'],
				password: [(v) => !!v || 'Password is a required field.'],
			},
		},
	}),

	methods: {
		async login() {
			if (this.$refs.loginForm.validate()) {
				this.form.loading = true;

				await this.$axios
					.post('/login', this.form.data)
					.then(async (res) => {
						var data = res.data;
						// Save the token.
						this.$store.dispatch('auth/saveToken', {
							token: data.token,
							remember: this.remember,
						});
						// Fetch the user.
						await this.$store.dispatch('auth/fetchUser');

						this.$router.push({ name: 'home' });
					})
					.catch((err) => {
						if (err.response.status == '403' || err.response.status == '422') {
							var x = '';
							this.$jquery.each(err.response.data.errors, (i, v) => {
								x += v + '<br>';
							});
							this.$toast.open({
								message: x,
								type: 'error',
								duration: 3000,
								pauseOnHover: true,
							});
						} else {
							throw err.response.data;
						}
					})
					.finally(() => {
						this.form.loading = false;
					});
			}
		},
	},
};
</script>
<style lang="scss" scoped>
.login-card-title {
	animation: moveUp 1s ease;
}

@keyframes moveUp {
	from {
		opacity: 0;
        transform: translateY(20px);
	}
	to {
		opacity: 1;
         transform: translateY(0);
	}
}
</style>
